#
# makeheader.rb
#
# create a header file with function defs from a source file
#
# by default, include all functions

ENV["LANG"]="C"

def create_c_defs(infile)
  ifile = open(infile, "r")
  oname=infile.gsub(/\.(|C|c|cc)$/,"-defs.h")
  ofile = open(oname,"w")
  ofile.print "// #{oname} created from #{infile}\n" 
  ofile.print "// at #{Time.now.to_s} by #{$0}\n\n" 
  localfunc = nil
  while s = ifile.gets
    s = s.chomp
    if s =~ /^\w\S*\s+(\w+).+\(/
      name = $1
      print "#{infile}: #{s}\n" if $DEBUG
      functionstring = s
      while s !~ /\)/
	s = ifile.gets.chomp
	functionstring += "\n"+s
      end
      if s =~ /\)\s*$/
	p s if $DEBUG
	ofile.print functionstring+";\n\n" unless localfunc
	localfunc=false
      end
    elsif s =~ /^\/\/\s*localfunc/
      localfunc = true
    end
  end
  ifile.close
  ofile.close
end

ARGV.each{|f| create_c_defs(f)}

